diff -rupN d:\t052/datasrc/compile.py d:\eg/datasrc/compile.py
--- d:\t052/datasrc/compile.py	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/datasrc/compile.py	2010-02-04 10:53:13.000000000 +0100
@@ -118,6 +118,7 @@ if gen_network_header:
 		
 	EmitEnum(["SOUND_%s"%i.name.value.upper() for i in content.container.sounds.items], "NUM_SOUNDS")
 	EmitEnum(["WEAPON_%s"%i.name.value.upper() for i in content.container.weapons.id.items], "NUM_WEAPONS")
+	EmitEnum(["SPECIAL_%s"%i.name.value.upper() for i in content.container.specials.id.items], "NUM_SPECIALS")
 
 	print "int netobj_validate(int type, void *data, int size);"
 	print "const char *netobj_get_name(int type);"
diff -rupN d:\t052/datasrc/content.py d:\eg/datasrc/content.py
--- d:\t052/datasrc/content.py	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/datasrc/content.py	2010-02-04 10:53:13.000000000 +0100
@@ -46,6 +46,14 @@ class Pickup(Struct):
 		self.name = String(name)
 		self.respawntime = Int(respawntime)
 		self.spawndelay = Int(spawndelay)
+		
+class SpecialSpec(Struct):
+	def __init__(self, name="", respawntime=15, spawndelay=0):
+		Struct.__init__(self, "SPECIALSPEC")
+		self.name = String(name)
+		self.respawntime = Int(respawntime)
+		self.spawndelay = Int(spawndelay)
+		self.duration = Int(30000)
 
 class AnimKeyframe(Struct):
 	def __init__(self, time=0, x=0, y=0, angle=0):
@@ -89,6 +97,8 @@ class WeaponSpec(Struct):
 		self.muzzleoffsetx = Float(0)
 		self.muzzleoffsety = Float(0)
 		self.muzzleduration = Float(5)
+		
+		self.bulletoffset = Float(12)
 
 		# dig out sprites if we have a container
 		if container:
@@ -138,6 +148,23 @@ class Weapon_Rifle(Struct):
 		self.bounce_num = Int(1)
 		self.bounce_cost = Float(0)
 		
+class Weapon_Shaft(Struct):
+	def __init__(self):
+		Struct.__init__(self, "WEAPONSPEC_SHAFT")
+		self.base = Pointer(WeaponSpec, WeaponSpec())
+		self.reach = Float(600.0)
+		
+class Weapon_Spingun(Struct):
+	def __init__(self):
+		Struct.__init__(self, "WEAPONSPEC_SPINGUN")
+		self.base = Pointer(WeaponSpec, WeaponSpec())
+		self.reach = Float(300.0)
+		
+class Weapon_Biorifle(Struct):
+	def __init__(self):
+		Struct.__init__(self, "WEAPONSPEC_BIORIFLE")
+		self.base = Pointer(WeaponSpec, WeaponSpec())
+		
 class Weapon_Ninja(Struct):
 	def __init__(self):
 		Struct.__init__(self, "WEAPONSPEC_NINJA")
@@ -145,18 +172,74 @@ class Weapon_Ninja(Struct):
 		self.duration = Int(15000)
 		self.movetime = Int(200)
 		self.velocity = Int(50)
+		
+class Weapon_Hook(Struct):
+	def __init__(self):
+		Struct.__init__(self, "WEAPONSPEC_HOOK")
+		self.base = Pointer(WeaponSpec, WeaponSpec())
 
 class Weapons(Struct):
 	def __init__(self):
 		Struct.__init__(self, "WEAPONSPECS")
 		self.hammer = Weapon_Hammer()
-		self.gun = Weapon_Hammer()
+		self.gun = Weapon_Gun()
 		self.shotgun = Weapon_Shotgun()
 		self.grenade = Weapon_Grenade()
 		self.rifle = Weapon_Rifle()
+		self.shaft = Weapon_Shaft()
+		self.spingun = Weapon_Spingun()
+		self.biorifle = Weapon_Biorifle()
 		self.ninja = Weapon_Ninja()
+		self.hook = Weapon_Hook()
 		self.id = Array(WeaponSpec())
 
+class SpecialSpec_Nospecial(Struct):
+	def __init__(self):
+		Struct.__init__(self, "SPECIALSPEC_NOSPECIAL")
+		self.base = Pointer(SpecialSpec, SpecialSpec())		
+		
+class SpecialSpec_Megahealth(Struct):
+	def __init__(self):
+		Struct.__init__(self, "SPECIALSPEC_MEGAHEALTH")
+		self.base = Pointer(SpecialSpec, SpecialSpec())
+		
+class SpecialSpec_Yellowarmor(Struct):
+	def __init__(self):
+		Struct.__init__(self, "SPECIALSPEC_YELLOWARMOR")
+		self.base = Pointer(SpecialSpec, SpecialSpec())
+		
+class SpecialSpec_Redarmor(Struct):
+	def __init__(self):
+		Struct.__init__(self, "SPECIALSPEC_REDARMOR")
+		self.base = Pointer(SpecialSpec, SpecialSpec())
+		
+class SpecialSpec_Powersuit(Struct):
+	def __init__(self):
+		Struct.__init__(self, "SPECIALSPEC_POWERSUIT")
+		self.base = Pointer(SpecialSpec, SpecialSpec())
+	
+class SpecialSpec_Ninjapwr(Struct):
+	def __init__(self):
+		Struct.__init__(self, "SPECIALSPEC_NINJAPWR")
+		self.base = Pointer(SpecialSpec, SpecialSpec())
+		
+class SpecialSpec_Hookpwr(Struct):
+	def __init__(self):
+		Struct.__init__(self, "SPECIALSPEC_HOOKPWR")
+		self.base = Pointer(SpecialSpec, SpecialSpec())
+
+class Specials(Struct):
+	def __init__(self):
+		Struct.__init__(self, "SPECIALSPECS")
+		self.nospecial = SpecialSpec_Nospecial()
+		self.megahealth = SpecialSpec_Megahealth()
+		self.yellowarmor = SpecialSpec_Yellowarmor()
+		self.redarmor = SpecialSpec_Redarmor()
+		self.powersuit = SpecialSpec_Powersuit()
+		self.ninjapwr = SpecialSpec_Ninjapwr()
+		self.hookpwr = SpecialSpec_Hookpwr()
+		self.id = Array(SpecialSpec())
+
 class DataContainer(Struct):
 	def __init__(self):
 		Struct.__init__(self, "DATACONTAINER")
@@ -167,6 +250,7 @@ class DataContainer(Struct):
 		self.sprites = Array(Sprite())
 		self.animations = Array(Animation())
 		self.weapons = Weapons()
+		self.specials = Specials()
 
 def FileList(format, num):
 	return [format%(x+1) for x in xrange(0,num)]
@@ -175,15 +259,21 @@ container = DataContainer()
 container.sounds.Add(SoundSet("gun_fire", FileList("audio/wp_gun_fire-%02d.wv", 3)))
 container.sounds.Add(SoundSet("shotgun_fire", FileList("audio/wp_shotty_fire-%02d.wv", 3)))
 
+container.sounds.Add(SoundSet("biorifle_fire", FileList("audio/wp_bio_fire-%02d.wv", 3)))
 container.sounds.Add(SoundSet("grenade_fire", FileList("audio/wp_flump_launch-%02d.wv", 3)))
 container.sounds.Add(SoundSet("hammer_fire", FileList("audio/wp_hammer_swing-%02d.wv", 3)))
 container.sounds.Add(SoundSet("hammer_hit", FileList("audio/wp_hammer_hit-%02d.wv", 3)))
 container.sounds.Add(SoundSet("ninja_fire", FileList("audio/wp_ninja_attack-%02d.wv", 3)))
+container.sounds.Add(SoundSet("spin_impact", FileList("audio/wp_spin_impact-%02d.wv", 3)))
 container.sounds.Add(SoundSet("grenade_explode", FileList("audio/wp_flump_explo-%02d.wv", 3)))
+container.sounds.Add(SoundSet("bio_explode", FileList("audio/wp_bio_explo-%02d.wv", 3)))
+container.sounds.Add(SoundSet("bio_impact", FileList("audio/wp_bio_impact-%02d.wv", 2)))
 container.sounds.Add(SoundSet("ninja_hit", FileList("audio/wp_ninja_hit-%02d.wv", 3)))
+container.sounds.Add(SoundSet("shaft_fire", FileList("audio/wp_shaft_fire-%02d.wv", 2)))
 container.sounds.Add(SoundSet("rifle_fire", FileList("audio/wp_rifle_fire-%02d.wv", 3)))
 container.sounds.Add(SoundSet("rifle_bounce", FileList("audio/wp_rifle_bnce-%02d.wv", 3)))
 container.sounds.Add(SoundSet("weapon_switch", FileList("audio/wp_switch-%02d.wv", 3)))
+container.sounds.Add(SoundSet("gold_attach_player", ["audio/wp_hook_attach.wv"]))
 
 container.sounds.Add(SoundSet("player_pain_short", FileList("audio/vo_teefault_pain_short-%02d.wv", 12)))
 container.sounds.Add(SoundSet("player_pain_long", FileList("audio/vo_teefault_pain_long-%02d.wv", 2)))
@@ -207,6 +297,8 @@ container.sounds.Add(SoundSet("pickup_ar
 container.sounds.Add(SoundSet("pickup_grenade", ["audio/sfx_pickup_launcher.wv"]))
 container.sounds.Add(SoundSet("pickup_shotgun", ["audio/sfx_pickup_sg.wv"]))
 container.sounds.Add(SoundSet("pickup_ninja", ["audio/sfx_pickup_ninja.wv"]))
+container.sounds.Add(SoundSet("pickup_suit", ["audio/sfx_pickup_suit.wv"]))
+container.sounds.Add(SoundSet("pickup_gold", ["audio/sfx_pickup_gold.wv"]))
 container.sounds.Add(SoundSet("weapon_spawn", FileList("audio/sfx_spawn_wpn-%02d.wv", 3)))
 container.sounds.Add(SoundSet("weapon_noammo", FileList("audio/wp_noammo-%02d.wv", 5)))
 
@@ -223,11 +315,13 @@ container.sounds.Add(SoundSet("ctf_captu
 image_null = Image("null", "")
 image_particles = Image("particles", "particles.png")
 image_game = Image("game", "game.png")
+image_egame = Image("egame", "egame.png")
 image_browseicons = Image("browseicons", "browse_icons.png")
 image_emoticons = Image("emoticons", "emoticons.png")
 
 container.images.Add(image_null)
 container.images.Add(image_game)
+container.images.Add(image_egame)
 container.images.Add(image_particles)
 container.images.Add(Image("cursor", "gui_cursor.png"))
 container.images.Add(Image("banner", "gui_logo.png"))
@@ -239,16 +333,18 @@ container.images.Add(Image("console_bar"
 container.pickups.Add(Pickup("health"))
 container.pickups.Add(Pickup("armor"))
 container.pickups.Add(Pickup("weapon"))
-container.pickups.Add(Pickup("ninja", 90, 90))
+container.pickups.Add(Pickup("special", 90, 90))
 
 set_particles = SpriteSet("particles", image_particles, 8, 8)
 set_game = SpriteSet("game", image_game, 32, 16)
+set_egame = SpriteSet("egame", image_egame, 32, 16)
 set_tee = SpriteSet("tee", image_null, 8, 4)
 set_browseicons = SpriteSet("browseicons", image_browseicons, 4, 1)
 set_emoticons = SpriteSet("emoticons", image_emoticons, 4, 4)
 
 container.spritesets.Add(set_particles)
 container.spritesets.Add(set_game)
+container.spritesets.Add(set_egame)
 container.spritesets.Add(set_tee)
 container.spritesets.Add(set_browseicons)
 container.spritesets.Add(set_emoticons)
@@ -264,8 +360,10 @@ container.sprites.Add(Sprite("part_shell
 container.sprites.Add(Sprite("part_expl01", set_particles, 0,4,4,4))
 container.sprites.Add(Sprite("part_airjump", set_particles, 2,2,2,2))
 
+container.sprites.Add(Sprite("health_overfill", set_egame, 10,0,2,2))
 container.sprites.Add(Sprite("health_full", set_game, 21,0,2,2))
 container.sprites.Add(Sprite("health_empty", set_game, 23,0,2,2))
+container.sprites.Add(Sprite("armor_overfill", set_egame, 10,2,2,2))
 container.sprites.Add(Sprite("armor_full", set_game, 21,2,2,2))
 container.sprites.Add(Sprite("armor_empty", set_game, 23,2,2,2))
 
@@ -313,6 +411,34 @@ container.sprites.Add(Sprite("weapon_rif
 container.sprites.Add(Sprite("weapon_rifle_cursor", set_game, 0,12,2,2))
 container.sprites.Add(Sprite("weapon_rifle_proj", set_game, 10,12,2,2))
 
+container.sprites.Add(Sprite("weapon_hook_body", set_game, 3,0,2,1))
+container.sprites.Add(Sprite("weapon_hook_cursor", set_game, 3,0,2,1))
+container.sprites.Add(Sprite("weapon_hook_proj", set_game, 3,0,2,1))
+
+container.sprites.Add(Sprite("weapon_shaft_body", set_egame, 2,0,7,4))
+container.sprites.Add(Sprite("weapon_shaft_cursor", set_egame, 0,1,2,2))
+container.sprites.Add(Sprite("weapon_shaft_proj", set_egame, 0,0,1,1))
+
+container.sprites.Add(Sprite("weapon_spingun_body", set_egame, 2,4,7,3))
+container.sprites.Add(Sprite("weapon_spingun_cursor", set_egame, 0,3,2,2))
+container.sprites.Add(Sprite("weapon_spingun_proj", set_egame, 10,4,2,2))
+container.sprites.Add(Sprite("weapon_spingun_vortex", set_egame, 19,0,4,4))
+container.sprites.Add(Sprite("weapon_spingun_lightning1", set_egame, 23,0,2,4))
+container.sprites.Add(Sprite("weapon_spingun_lightning2", set_egame, 25,0,2,4))
+container.sprites.Add(Sprite("weapon_spingun_halo", set_egame, 27,0,4,4))
+
+container.sprites.Add(Sprite("weapon_biorifle_body", set_egame, 2,7,7,3))
+container.sprites.Add(Sprite("weapon_biorifle_cursor", set_egame, 0,5,2,2))
+container.sprites.Add(Sprite("weapon_biorifle_proj", set_egame, 27,0,4,4))
+container.sprites.Add(Sprite("weapon_biorifle_sticky1", set_egame, 0,9,2,2))
+container.sprites.Add(Sprite("weapon_biorifle_sticky2", set_egame, 0,11,2,2))
+container.sprites.Add(Sprite("weapon_biorifle_splash", set_egame, 0,13,2,2))
+
+container.sprites.Add(Sprite("shaft_end1", set_egame, 13,2,2,2))
+container.sprites.Add(Sprite("shaft_end2", set_egame, 15,2,2,2))
+container.sprites.Add(Sprite("shaft_end3", set_egame, 17,2,2,2))
+container.sprites.Add(Sprite("shaft_beam1", set_egame, 13,4,7,2))
+
 container.sprites.Add(Sprite("hook_chain", set_game, 2,0,1,1))
 container.sprites.Add(Sprite("hook_head", set_game, 3,0,2,1))
 
@@ -452,6 +578,7 @@ container.weapons.id.Add(weapon)
 weapon = WeaponSpec(container, "grenade")
 weapon.firedelay.Set(500) # TODO: fix this
 weapon.visual_size.Set(96)
+weapon.damage.Set(6)
 weapon.offsetx.Set(24)
 weapon.offsety.Set(-2)
 container.weapons.grenade.base.Set(weapon)
@@ -466,6 +593,41 @@ weapon.offsety.Set(-2)
 container.weapons.rifle.base.Set(weapon)
 container.weapons.id.Add(weapon)
 
+weapon = WeaponSpec(container, "shaft")
+weapon.firedelay.Set(55)
+weapon.maxammo.Set(100)
+weapon.damage.Set(1)
+weapon.visual_size.Set(115)
+weapon.offsetx.Set(24)
+weapon.offsety.Set(-2)
+weapon.bulletoffset.Set(1.75)
+container.weapons.shaft.base.Set(weapon)
+container.weapons.id.Add(weapon)
+
+weapon = WeaponSpec(container, "spingun")
+weapon.firedelay.Set(1000)
+weapon.maxammo.Set(5)
+weapon.damage.Set(12)
+weapon.visual_size.Set(96)
+weapon.offsetx.Set(24)
+weapon.offsety.Set(-2)
+weapon.bulletoffset.Set(24)
+container.weapons.spingun.base.Set(weapon)
+container.weapons.id.Add(weapon)
+
+weapon = WeaponSpec(container, "biorifle")
+weapon.firedelay.Set(140)
+weapon.maxammo.Set(35)
+weapon.visual_size.Set(100)
+weapon.damage.Set(2)
+weapon.offsetx.Set(24)
+weapon.offsety.Set(0)
+weapon.bulletoffset.Set(3)
+weapon.muzzleoffsetx.Set(50)
+weapon.muzzleoffsety.Set(6)
+container.weapons.biorifle.base.Set(weapon)
+container.weapons.id.Add(weapon)
+
 weapon = WeaponSpec(container, "ninja")
 weapon.firedelay.Set(800)
 weapon.damage.Set(9)
@@ -476,3 +638,42 @@ weapon.muzzleoffsetx.Set(40)
 weapon.muzzleoffsety.Set(-4)
 container.weapons.ninja.base.Set(weapon)
 container.weapons.id.Add(weapon)
+
+weapon = WeaponSpec(container, "hook")
+weapon.firedelay.Set(10)
+weapon.damage.Set(0)
+weapon.visual_size.Set(0)
+weapon.offsetx.Set(0)
+weapon.offsety.Set(0)
+weapon.muzzleoffsetx.Set(0)
+weapon.muzzleoffsety.Set(0)
+container.weapons.hook.base.Set(weapon)
+container.weapons.id.Add(weapon)
+
+special = SpecialSpec("nospecial", 0, 0)
+container.specials.nospecial.base.Set(special)
+container.specials.id.Add(special)
+
+special = SpecialSpec("megahealth", 35, 10)
+container.specials.megahealth.base.Set(special)
+container.specials.id.Add(special)
+
+special = SpecialSpec("yellowarmor", 25, 1)
+container.specials.yellowarmor.base.Set(special)
+container.specials.id.Add(special)
+
+special = SpecialSpec("redarmor", 25, 1)
+container.specials.redarmor.base.Set(special)
+container.specials.id.Add(special)
+
+special = SpecialSpec("powersuit", 30, 10)
+container.specials.powersuit.base.Set(special)
+container.specials.id.Add(special)
+
+special = SpecialSpec("ninjapwr", 30, 15)
+container.specials.ninjapwr.base.Set(special)
+container.specials.id.Add(special)
+
+special = SpecialSpec("hookpwr", 60, 45)
+container.specials.hookpwr.base.Set(special)
+container.specials.id.Add(special)
\ No newline at end of file
diff -rupN d:\t052/datasrc/network.py d:\eg/datasrc/network.py
--- d:\t052/datasrc/network.py	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/datasrc/network.py	2010-02-04 10:53:13.000000000 +0100
@@ -6,7 +6,7 @@ GameFlags = ["TEAMS", "FLAGS"]
 
 Emoticons = [str(x) for x in xrange(1,16)]
 
-Powerups = ["HEALTH", "ARMOR", "WEAPON", "NINJA"]
+Powerups = ["HEALTH", "ARMOR", "WEAPON", "SPECIAL"]
 
 RawHeader = '''
 enum
@@ -41,6 +41,7 @@ Objects = [
 		NetIntAny("jump"),
 		NetIntAny("fire"),
 		NetIntAny("hook"),
+		NetIntAny("drop"),
 		
 		NetIntRange("player_state", 0, len(PlayerStates)),
 		
@@ -58,13 +59,25 @@ Objects = [
 		NetIntRange("type", 0, 'NUM_WEAPONS-1'),
 		NetTick("start_tick"),
 	]),
-
+	
 	NetObject("Laser", [
 		NetIntAny("x"),
 		NetIntAny("y"),
 		NetIntAny("from_x"),
 		NetIntAny("from_y"),
 		
+		NetIntRange("type", 0, 'NUM_WEAPONS-1'),
+		NetTick("start_tick"),
+	]),
+	
+	NetObject("Shaft_Beam", [
+		NetIntAny("x"),
+		NetIntAny("y"),
+		NetIntAny("from_x"),
+		NetIntAny("from_y"),
+		NetIntAny("playerID"),
+		
+		NetIntRange("type", 0, 'NUM_WEAPONS-1'),
 		NetTick("start_tick"),
 	]),
 
@@ -75,6 +88,16 @@ Objects = [
 		NetIntRange("type", 0, 'max_int'),
 		NetIntRange("subtype", 0, 'max_int'),
 	]),
+	
+	NetObject("Dropped_Weapon", [
+		NetIntAny("x"),
+		NetIntAny("y"),
+		NetIntAny("vx"),
+		NetIntAny("vy"),
+		
+		NetIntRange("subtype", 0, 'max_int'),
+		NetTick("start_tick"),
+	]),
 
 	NetObject("Flag", [
 		NetIntAny("x"),
@@ -118,6 +141,8 @@ Objects = [
 		NetIntRange("hooked_player", 0, 'MAX_CLIENTS-1'),
 		NetIntRange("hook_state", -1, 5),
 		NetTick("hook_tick"),
+		
+		NetIntRange("specialstate", 0, 3),
 
 		NetIntAny("hook_x"),
 		NetIntAny("hook_y"),
@@ -127,9 +152,9 @@ Objects = [
 
 	NetObject("Character:Character_Core", [
 		NetIntRange("player_state", 0, 'NUM_PLAYERSTATES-1'),
-		NetIntRange("health", 0, 10),
-		NetIntRange("armor", 0, 10),
-		NetIntRange("ammocount", 0, 10),
+		NetIntRange("health", 0, 20),
+		NetIntRange("armor", 0, 20),
+		NetIntRange("ammocount", 0, 100),
 		NetIntRange("weapon", 0, 'NUM_WEAPONS-1'),
 		NetIntRange("emote", 0, len(Emotes)),
 		NetIntRange("attacktick", 0, 'max_int'),
@@ -140,7 +165,18 @@ Objects = [
 		NetIntRange("cid", 0, 'MAX_CLIENTS-1'),
 		NetIntRange("team", -1, 1),
 
+		NetIntRange("overall_accuracy", 0, 100),
+		# NetIntRange("hammer_percentage", 0, 100),
+		# NetIntRange("gun_percentage", 0, 100),
+		# NetIntRange("shotgun_percentage", 0, 100),
+		# NetIntRange("grenade_percentage", 0, 100),
+		# NetIntRange("rifle_percentage", 0, 100),
+		# NetIntRange("shaft_percentage", 0, 100),
+		# NetIntRange("spin_percentage", 0, 100),
+		# NetIntRange("bio_percentage", 0, 100),
+		
 		NetIntAny("score"),
+		NetIntAny("netscore"),
 		NetIntAny("latency"),
 		NetIntAny("latency_flux"),
 	]),
@@ -171,6 +207,9 @@ Objects = [
 	NetEvent("Explosion:Common", []),
 	NetEvent("Spawn:Common", []),
 	NetEvent("HammerHit:Common", []),
+	NetEvent("BioSplash:Common", [
+		NetIntAny("playSound"),
+	]),
 	
 	NetEvent("Death:Common", [
 		NetIntRange("cid", 0, 'MAX_CLIENTS-1'),
diff -rupN d:\t052/default.bam d:\eg/default.bam
--- d:\t052/default.bam	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/default.bam	2010-02-04 10:53:13.000000000 +0100
@@ -112,8 +112,8 @@ function build(settings)
 	else
 		settings.cc.flags:Add("-Wall", "-fno-exceptions")
 		if platform == "macosx" then
-			settings.cc.flags:Add("-mmacosx-version-min=10.4", "-isysroot /Developer/SDKs/MacOSX10.4u.sdk")
-			settings.link.flags:Add("-mmacosx-version-min=10.4", "-isysroot /Developer/SDKs/MacOSX10.4u.sdk")
+			settings.cc.flags:Add("-mmacosx-version-min=10.5", "-isysroot /Developer/SDKs/MacOSX10.5.sdk")
+			settings.link.flags:Add("-mmacosx-version-min=10.5", "-isysroot /Developer/SDKs/MacOSX10.5.sdk")
 		elseif config.stackprotector.value == 1 then
 			settings.cc.flags:Add("-fstack-protector", "-fstack-protector-all")
 			settings.link.flags:Add("-fstack-protector", "-fstack-protector-all")
diff -rupN d:\t052/src/engine/client/ec_gfx.c d:\eg/src/engine/client/ec_gfx.c
--- d:\t052/src/engine/client/ec_gfx.c	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/engine/client/ec_gfx.c	2010-02-04 10:53:13.000000000 +0100
@@ -463,6 +463,13 @@ void gfx_blend_additive()
 	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
 }
 
+void gfx_blend_subtractive()
+{
+	if(no_gfx) return;
+	glEnable(GL_BLEND);
+	glBlendFunc(GL_ZERO, GL_ONE_MINUS_SRC_ALPHA);
+}
+
 int gfx_memory_usage() { return memory_usage; }
 
 static unsigned char sample(int w, int h, const unsigned char *data, int u, int v, int offset)
diff -rupN d:\t052/src/engine/e_if_gfx.h d:\eg/src/engine/e_if_gfx.h
--- d:\t052/src/engine/e_if_gfx.h	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/engine/e_if_gfx.h	2010-02-04 10:53:13.000000000 +0100
@@ -506,6 +506,8 @@ void gfx_blend_normal();
 */
 void gfx_blend_additive();
 
+void gfx_blend_subtractive();
+
 /*
 	Function: gfx_blend_none
 		Disables blending
diff -rupN d:\t052/src/game/client/components/binds.cpp d:\eg/src/game/client/components/binds.cpp
--- d:\t052/src/game/client/components/binds.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/client/components/binds.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -86,6 +86,7 @@ void BINDS::set_defaults()
 	bind(KEY_F2, "toggle_remote_console");
 	bind(KEY_TAB, "+scoreboard");
 	bind(KEY_F10, "screenshot");
+	bind('^', "personal_scoreboard");
 
 	bind('a', "+left");
 	bind('d', "+right");
@@ -100,10 +101,15 @@ void BINDS::set_defaults()
 	bind('3', "+weapon3");
 	bind('4', "+weapon4");
 	bind('5', "+weapon5");
+	bind('6', "+weapon6");
+	bind('7', "+weapon7");
+	bind('8', "+weapon8");
 	
 	bind(KEY_MOUSE_WHEEL_UP, "+prevweapon");
 	bind(KEY_MOUSE_WHEEL_DOWN, "+nextweapon");
 	
+	bind('f', "+dropweapon");
+	
 	bind('t', "chat all");
 	bind('y', "chat team");	
 
diff -rupN d:\t052/src/game/client/components/controls.cpp d:\eg/src/game/client/components/controls.cpp
--- d:\t052/src/game/client/components/controls.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/client/components/controls.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -53,12 +53,16 @@ void CONTROLS::on_console_init()
 	MACRO_REGISTER_COMMAND("+jump", "", CFGFLAG_CLIENT, con_key_input_state, &input_data.jump, "Jump");
 	MACRO_REGISTER_COMMAND("+hook", "", CFGFLAG_CLIENT, con_key_input_state, &input_data.hook, "Hook");
 	MACRO_REGISTER_COMMAND("+fire", "", CFGFLAG_CLIENT, con_key_input_counter, &input_data.fire, "Fire");
+	MACRO_REGISTER_COMMAND("+dropweapon", "", CFGFLAG_CLIENT, con_key_input_state, &input_data.drop, "Drop Weapon");
 
 	{ static INPUTSET set = {this, &input_data.wanted_weapon, 1};  MACRO_REGISTER_COMMAND("+weapon1", "", CFGFLAG_CLIENT, con_key_input_set, (void *)&set, "Switch to hammer"); }
 	{ static INPUTSET set = {this, &input_data.wanted_weapon, 2};  MACRO_REGISTER_COMMAND("+weapon2", "", CFGFLAG_CLIENT, con_key_input_set, (void *)&set, "Switch to gun"); }
 	{ static INPUTSET set = {this, &input_data.wanted_weapon, 3};  MACRO_REGISTER_COMMAND("+weapon3", "", CFGFLAG_CLIENT, con_key_input_set, (void *)&set, "Switch to shotgun"); }
 	{ static INPUTSET set = {this, &input_data.wanted_weapon, 4};  MACRO_REGISTER_COMMAND("+weapon4", "", CFGFLAG_CLIENT, con_key_input_set, (void *)&set, "Switch to grenade"); }
 	{ static INPUTSET set = {this, &input_data.wanted_weapon, 5};  MACRO_REGISTER_COMMAND("+weapon5", "", CFGFLAG_CLIENT, con_key_input_set, (void *)&set, "Switch to rifle"); }
+	{ static INPUTSET set = {this, &input_data.wanted_weapon, 6};  MACRO_REGISTER_COMMAND("+weapon6", "", CFGFLAG_CLIENT, con_key_input_set, (void *)&set, "Switch to shaft"); }
+	{ static INPUTSET set = {this, &input_data.wanted_weapon, 7};  MACRO_REGISTER_COMMAND("+weapon7", "", CFGFLAG_CLIENT, con_key_input_set, (void *)&set, "Switch to spin gun"); }
+	{ static INPUTSET set = {this, &input_data.wanted_weapon, 8};  MACRO_REGISTER_COMMAND("+weapon8", "", CFGFLAG_CLIENT, con_key_input_set, (void *)&set, "Switch to bio-rifle"); }
 
 	{ static INPUTSET set = {this, &input_data.next_weapon, 0};  MACRO_REGISTER_COMMAND("+nextweapon", "", CFGFLAG_CLIENT, con_key_input_nextprev_weapon, (void *)&set, "Switch to next weapon"); }
 	{ static INPUTSET set = {this, &input_data.prev_weapon, 0};  MACRO_REGISTER_COMMAND("+prevweapon", "", CFGFLAG_CLIENT, con_key_input_nextprev_weapon, (void *)&set, "Switch to previous weapon"); }
@@ -99,6 +103,7 @@ int CONTROLS::snapinput(int *data)
 		last_data.direction = 0;
 		last_data.hook = 0;
 		last_data.jump = 0;
+		last_data.drop = 0;
 		input_data = last_data;
 		
 		input_direction_left = 0;
@@ -145,6 +150,7 @@ int CONTROLS::snapinput(int *data)
 		else if(input_data.jump != last_data.jump) send = true;
 		else if(input_data.fire != last_data.fire) send = true;
 		else if(input_data.hook != last_data.hook) send = true;
+		else if(input_data.drop != last_data.drop) send = true;
 		else if(input_data.player_state != last_data.player_state) send = true;
 		else if(input_data.wanted_weapon != last_data.wanted_weapon) send = true;
 		else if(input_data.next_weapon != last_data.next_weapon) send = true;
diff -rupN d:\t052/src/game/client/components/effects.cpp d:\eg/src/game/client/components/effects.cpp
--- d:\t052/src/game/client/components/effects.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/client/components/effects.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -42,6 +42,30 @@ void EFFECTS::air_jump(vec2 pos)
 	gameclient.sounds->play(SOUNDS::CHN_WORLD, SOUND_PLAYER_AIRJUMP, 1.0f, pos);
 }
 
+void EFFECTS::biosplash(vec2 pos, bool sound)
+{
+	int num = 10;
+	for (int i=0; i<num; i++)
+	{
+		PARTICLE p;
+		p.set_default();
+		p.spr = SPRITE_PART_SMOKE;
+		p.pos = pos;
+		p.vel = vec2(frandom(), frandom())*800;
+		p.start_size = 15.0f + frandom()*8;
+		p.gravity = frandom()*500.0f;
+		p.start_size = 8.0f + frandom()*4;
+		p.life_span = 0.2 + frandom()*0.3f;		
+		p.end_size = 0;
+		p.friction = 1;
+		
+		p.color = vec4(0.75f,0.15f,0.85f,1.0f);
+		p.flow_affected = 0;		
+		gameclient.particles->add(PARTICLES::GROUP_PROJECTILE_TRAIL, &p);					
+	}	
+	gameclient.sounds->play(SOUNDS::CHN_WORLD, SOUND_BIO_EXPLODE, 1.0f, pos);
+}
+
 void EFFECTS::damage_indicator(vec2 pos, vec2 dir)
 {
 	gameclient.damageind->create(pos, dir);
diff -rupN d:\t052/src/game/client/components/effects.hpp d:\eg/src/game/client/components/effects.hpp
--- d:\t052/src/game/client/components/effects.hpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/client/components/effects.hpp	2010-02-04 10:53:13.000000000 +0100
@@ -17,6 +17,7 @@ public:
 	void air_jump(vec2 pos);
 	void damage_indicator(vec2 pos, vec2 dir);
 	void playerspawn(vec2 pos);
+	void biosplash(vec2 pos, bool sound);
 	void playerdeath(vec2 pos, int cid);
 	void powerupshine(vec2 pos, vec2 size);
 
diff -rupN d:\t052/src/game/client/components/hud.cpp d:\eg/src/game/client/components/hud.cpp
--- d:\t052/src/game/client/components/hud.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/client/components/hud.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -227,7 +227,12 @@ void HUD::render_cursor()
 		return;
 		
 	mapscreen_to_group(gameclient.camera->center.x, gameclient.camera->center.y, layers_game_group());
-	gfx_texture_set(data->images[IMAGE_GAME].id);
+	if ((gameclient.snap.local_character->weapon == WEAPON_SPINGUN) ||
+	    (gameclient.snap.local_character->weapon == WEAPON_SHAFT) ||
+		(gameclient.snap.local_character->weapon == WEAPON_BIORIFLE))
+		gfx_texture_set(data->images[IMAGE_EGAME].id);
+	else
+		gfx_texture_set(data->images[IMAGE_GAME].id);
 	gfx_quads_begin();
 
 	// render cursor
@@ -250,31 +255,72 @@ void HUD::render_healthandammo()
 	gfx_texture_set(data->images[IMAGE_GAME].id);
 	gfx_mapscreen(0,0,width,300);
 	
-	gfx_quads_begin();
+	int w = gameclient.snap.local_character->weapon;
+	
+	if ((w == WEAPON_SHAFT) || (w==WEAPON_SPINGUN) || (w==WEAPON_BIORIFLE))
+		gfx_texture_set(data->images[IMAGE_EGAME].id);
+	else
+		gfx_texture_set(data->images[IMAGE_GAME].id);
+	
+	// added offset variable
+	int bulletoffset = data->weapons.id[gameclient.snap.local_character->weapon%NUM_WEAPONS].bulletoffset;
+	gfx_quads_begin();	
+		// if weaponstage is active, put a "glow" around the stage ammo
+		select_sprite(data->weapons.id[gameclient.snap.local_character->weapon%NUM_WEAPONS].sprite_proj);
+		for (int i = 0; i < min(gameclient.snap.local_character->ammocount, 100); i++)
+		{
+			gfx_quads_drawTL(x+i*bulletoffset,y+24,10,10);
+		}
+	
 	
-	// if weaponstage is active, put a "glow" around the stage ammo
-	select_sprite(data->weapons.id[gameclient.snap.local_character->weapon%NUM_WEAPONS].sprite_proj);
-	for (int i = 0; i < min(gameclient.snap.local_character->ammocount, 10); i++)
-		gfx_quads_drawTL(x+i*12,y+24,10,10);
-
 	gfx_quads_end();
 
+
+
+	gfx_texture_set(data->images[IMAGE_EGAME].id);
+
 	gfx_quads_begin();
 	int h = 0;
 
 	// render health
+	select_sprite(SPRITE_HEALTH_OVERFILL);
+	for(; h < (gameclient.snap.local_character->health - 10); h++)
+		gfx_quads_drawTL(x+h*12,y,10,10);
+	
+	gfx_quads_end();
+	
+	gfx_texture_set(data->images[IMAGE_GAME].id);
+	
+	gfx_quads_begin();
+	
 	select_sprite(SPRITE_HEALTH_FULL);
-	for(; h < gameclient.snap.local_character->health; h++)
+	for(int z = h; h < (gameclient.snap.local_character->health - z); h++)
 		gfx_quads_drawTL(x+h*12,y,10,10);
 
 	select_sprite(SPRITE_HEALTH_EMPTY);
 	for(; h < 10; h++)
 		gfx_quads_drawTL(x+h*12,y,10,10);
 
+	gfx_quads_end();
+	
+	gfx_texture_set(data->images[IMAGE_EGAME].id);
+
+	gfx_quads_begin();
+	
 	// render armor meter
 	h = 0;
+	select_sprite(SPRITE_ARMOR_OVERFILL);
+	for(; h < (gameclient.snap.local_character->armor - 10); h++)
+		gfx_quads_drawTL(x+h*12,y+12,10,10);
+		
+	gfx_quads_end();
+	
+	gfx_texture_set(data->images[IMAGE_GAME].id);
+	
+	gfx_quads_begin();
+	
 	select_sprite(SPRITE_ARMOR_FULL);
-	for(; h < gameclient.snap.local_character->armor; h++)
+	for(int z = h; h < (gameclient.snap.local_character->armor - z); h++)
 		gfx_quads_drawTL(x+h*12,y+12,10,10);
 
 	select_sprite(SPRITE_ARMOR_EMPTY);
